#!/usr/bin/env python
# -*- coding:Utf-8 -*-
# Module rend
# Official Addons
# By Sicilia

import es, playerlib, gamethread, math

max_rend = es.ServerVar("max_rend")
temps_rend = es.ServerVar("temps_rend")
distance_sup = es.ServerVar("distance_sup")



dico_rend = {}


def load():
    es.regclientcmd("!rend", "sici_jail/modules/rend/player_cmd_rend", "remove closest weapon")
    es.regsaycmd("!rend", "sici_jail/modules/rend/player_cmd_rend", "remove closest weapon")
    es.dbgmsg(0, '[Sici Jail] Modules : Rend On')
        
def round_start(E):
    global dico_rend
    dico_rend.clear()
    
def player_spawn(E):
    if E["es_userteam"] == "2":        
        es.tell(E["userid"], "#multi", "#lightgreen[#greenSici Jail#lightgreen] #defaultOublie pas pour se rendre : #green!rend")


def player_cmd_rend():     
    global dico_rend
    userid = es.getcmduserid()
    play = playerlib.getPlayer(userid)   
    if play.get("isdead") == 0:    
        team = es.getplayerteam(userid)
        if team == 2:
            if not userid in dico_rend:
                dico_rend[userid] = [0, False]
            if dico_rend[userid][0] < int(max_rend) and not dico_rend[userid][1]:
                dico_rend[userid][0] += 1
                enlever_arme(userid)
                Rends(userid, distance_sup)
                name = es.getplayername(userid)
                es.msg("#multi", "#lightgreen[#greenSici Jail#lightgreen] #lightgreen%s #default se rend !!! pendant #green%s#default sec." % (name, temps_rend))
            elif dico_rend[userid][0] == int(max_rend):
                es.tell(userid, "#multi", "#lightgreen[#greenSici Jail#lightgreen] #defaultTes #lightgreen'!rend'#default ont déjà été tous utilisés.")
            elif dico_rend[userid][1]:
                es.tell(userid, "#multi", "#lightgreen[#greenSici Jail#lightgreen] #green'!rend'#default est deja en cour d'utilisation.")
                
def enlever_arme(userid):
    global dico_rend
    dico_rend[userid][1] = True
    es.server.cmd("es_xfire %s player_weaponstrip kill;" % userid +
                  "es_xgive %s player_weaponstrip;" % userid +
                  "es_xfire %s player_weaponstrip strip" % userid)
    es.setplayerprop(userid, "CBasePlayer.m_lifeState", 0)
    es.setplayerprop(userid, "CBasePlayer.m_fFlags", 32.0)
    gamethread.delayed(temps_rend, regive_vies, (userid))
    
def regive_vies(userid):
    global dico_rend
    dico_rend[userid][1] = False
    es.server.queuecmd("es_xgive %s weapon_knife" % userid)
    es.setplayerprop(userid, "CBasePlayer.m_lifeState", 512)
    es.setplayerprop(userid, "CBasePlayer.m_fFlags", 66177)

class Rends:
    """
        Remove weapon at ground
    """

    def __init__(self, i = 0, d = 0):
        self._dist = {}
        if i: self.__find(i, d)

    def __dist(self, V1, V2):
        return math.sqrt(math.pow(V1[0] - V2[0], 2) + math.pow(V1[1] - V2[1], 2) + math.pow(V1[2] - V2[2], 2))

    def __maxi(self, I, D):
        self._dist[D] = I

    def __find(self, i, d = 0):
        enti = es.createentitylist()
        vect = {}

        for indx in enti:
            if enti[indx]["classname"].startswith("weapon_"):
                if es.getindexprop(indx, "CBaseCombatWeapon.m_hOwner") == -1: vect[indx] = []

        if len(vect):
            for indx in vect:
                map(lambda x: vect[indx].append(float(x)), es.getindexprop(indx, "CBaseEntity.m_vecOrigin").split(","))

            user = es.getplayerlocation(i)
            map(lambda x: self.__maxi(x, self.__dist(user, vect[x])), vect)

            if d == 0: es.server.queuecmd("es_xremove %s" % self._dist[dist])
            else:
                for dist, index in self._dist.items():
                    if dist * 0.0254 < float(d): es.server.queuecmd("es_xremove %s" % self._dist[dist])

def unload():
    es.unregclientcmd("!rend")    
    es.unregsaycmd("!rend")
    es.dbgmsg(0, '[Sici Jail] Modules : Rend Off')